public class Hangman {
    private String secretWord;
    private String currWord;
    private int attemp;
    private int failedAttempt;
    private boolean lastTry;

    private Hangman(String word){
        this.secretWord = word;
        this.currWord = "_".repeat(word.length());
        this.attemp = 0;
        this.failedAttempt = 0;
        this.lastTry = true;
        
    }
    public static Hangman withSecretWord(String word){
        return new Hangman(word);
    } 
    private String currentWord(){
        return this.currWord;
    }

    public void printCurrentWord(){
        System.out.println("Current Word:" + this.currentWord());
    }
    private int attemps(){
        return this.attemp;
    }
    private String secretWord(){
        return this.secretWord;
    }
    private boolean lastTry(){
        return this.lastTry;
    }
    public int failedAttempts(){
        return this.failedAttempt;
    }
    public void printGallow(){
        printHang(this.failedAttempts());
    }
    public void printGallowIfError(){
        if (!this.lastTry()){
            printHang(this.failedAttempts());
        }
    } 
    private String check(char letter){
        StringBuilder newStr = new StringBuilder(this.currentWord());
        for ( int i = 0; i < this.secretWord().length(); i++){
            if (this.secretWord().charAt(i) == letter){
                newStr.setCharAt(i, letter);
            }
        }
        return newStr.toString();
    }

    public Hangman tryWith(char letter){
        Hangman newH = this;
        newH.attemp++;
        String checked = check(letter);
        if (newH.currentWord().equals(checked)){
            newH.failedAttempt++;
            newH.lastTry = false;
            return newH;
        }
        newH.lastTry = true;
        newH.currWord = checked;
        return newH;
    }
  

    public boolean isFinished(){
        if (this.failedAttempts() == 9 || !this.currentWord().contains("_")){
            return true;
        }
        return false;
    }

    public boolean hasWon(){
        if (this.failedAttempts()==9){
            return false;
        }
        return true;
    } 

    private static void printHang(int i){
        String i0 = "";
        String i1 = "----------\n|/\n|\n|\n|\n|\n|\n|";
        String i2 = "----------\n|/       |\n|\n|\n|\n|\n|\n|";
        String i3 = "----------\n|/       |\n|       (.)\n|\n|\n|\n|\n|";
        String i4 = "----------\n|/       |\n|       (̣̣ )\n|        |\n|\n|\n|\n|";
        String i5 = "----------\n|/       |\n|       (̣̣ )\n|       /|\n|\n|\n|\n|";
        String i6 = "----------\n|/       |\n|       (̣̣ )\n|       /|\\ \n|\n|\n|\n|";
        String i7 = "----------\n|/       |\n|       (̣̣ )\n|       /|\\ \n|        | \n|\n|\n|";
        String i8 = "----------\n|/       |\n|       (̣̣ )\n|       /|\\\n|        | \n|       /  \n|\n|";
        String i9 = "----------\n|/       |\n|       (̣̣ )\n|       /|\\\n|        | \n|       / \\\n|\n|";
        String [] drawHangMan = {i0, i1, i2, i3, i4, i5, i6, i7, i8, i9};
        System.out.println(drawHangMan[i]);     
    }
    public static void main(String[] args){
        Hangman h = Hangman.withSecretWord("mystère");
        String currentWord = h.currentWord();
        

    }

    
}